---
title: function* expression
slug: Web/JavaScript/Reference/Operators/function*
tags:
  - ECMAScript 2015
  - Function
  - Iterator
  - JavaScript
  - Language feature
  - Operator
  - Primary Expression
---
<div>{{jsSidebar("Operators")}}</div>

<p>The <strong><code>function*</code></strong> keyword can be used to define a generator function inside an expression.</p>

<div>{{EmbedInteractiveExample("pages/js/expressions-functionasteriskexpression.html", "taller")}}</div>

<div class="hidden">The source for this interactive example is stored in a GitHub repository. If you'd like to contribute to the interactive examples project, please clone <a href="https://github.com/mdn/interactive-examples">https://github.com/mdn/interactive-examples</a> and send us a pull request.</div>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">function* [<var>name</var>]([<var>param1</var>[, <var>param2[</var>, ..., <var>paramN</var>]]]) {
   <var>statements</var>
}</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code><var>name</var></code> {{optional_inline}}</dt>
 <dd>The function name. Can be omitted, in which case the function is <em>anonymous</em>. The name is only local to the function body.</dd>
 <dt><code><var>paramN</var></code><var> </var> {{optional_inline}}</dt>
 <dd>The name of an argument to be passed to the function. A function can have up to 255 arguments.</dd>
 <dt><code><var>statements</var></code></dt>
 <dd>The statements which comprise the body of the function.</dd>
</dl>

<h2 id="Description">Description</h2>

<p>A <code>function*</code> expression is very similar to and has almost the same syntax as a {{jsxref('Statements/function*', 'function* statement', "", 1)}}. The main difference between a <code>function*</code> expression and a <code>function*</code> statement is the <em>function name</em>, which can be omitted in <code>function*</code> expressions to create <em>anonymous</em> generator functions. See also the chapter about {{jsxref("Functions", "functions")}} for more information.</p>

<h2 id="Examples">Examples</h2>

<h3 id="Using_function*">Using function*</h3>

<p>The following example defines an unnamed generator function and assigns it to <code>x</code>. The function yields the square of its argument:</p>

<pre class="brush: js">let x = function*(y) {
   yield y * y;
};
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('ESDraft', '#sec-generator-function-definitions', 'function*')}}</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("javascript.operators.function_star")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{jsxref("Statements/function*", "function*")}} statement</li>
 <li>{{jsxref("GeneratorFunction")}} object</li>
 <li><a href="/en-US/docs/Web/JavaScript/Reference/Iteration_protocols">The Iterator protocol</a></li>
 <li>{{jsxref("Operators/yield", "yield")}}</li>
 <li>{{jsxref("Operators/yield*", "yield*")}}</li>
 <li>{{jsxref("Function")}} object</li>
 <li>{{jsxref("Statements/function", "function")}} statement</li>
 <li>{{jsxref("Operators/function", "function")}} expression</li>
 <li>{{jsxref("Functions_and_function_scope", "Functions and function scope", "", 1)}}</li>
</ul>
